API ReferenceProduct Variants

Batch create product variants

Create multiple variants for a product in one request by sending a resources array.

Create multiple variants for a product in one request by sending a resources array.

POST
/v2/products/{product}/variants/batch

Authorization

AuthorizationBearer <token>

Provide your SellApp API key as a bearer token.

In: header

Path Parameters

product*integer

The product path parameter.

Header Parameters

X-STORE?string

Store slug. Required for OAuth access tokens. API keys may omit it to use their current store, or the first accessible store when no current store is selected.

Request Body

application/json

TypeScript Definitions

Use the request body type in TypeScript.

Response Body

application/json

application/json

application/json

application/json

application/json

application/json

application/json

application/json

application/json

curl -X POST "https://sell.app/api/v2/products/1/variants/batch" \  -H "X-STORE: launch-lab" \  -H "Content-Type: application/json" \  -d '{    "resources": [      {        "title": "Default",        "description": "Default product variant.",        "deliverable": {          "types": [            "TEXT"          ],          "data": {            "serials": [              "SERIAL-001"            ],            "parsingMode": "NEW_LINE",            "removeDuplicate": true          }        },        "pricing": {          "humble": false,          "price": {            "price": 1000,            "currency": "USD"          }        },        "payment_methods": [          "PAYPAL"        ]      }    ]  }'
{
  "data": [
    {
      "id": 2,
      "product_id": 1,
      "title": "Default",
      "description": "Default product variant.",
      "deliverable": {
        "types": [
          "TEXT"
        ],
        "data": {
          "serials": [
            "SERIAL-001"
          ],
          "parsingMode": "NEW_LINE",
          "removeDuplicate": true,
          "stock": 1
        }
      },
      "pricing": {
        "humble": false,
        "frequency": {
          "value": 1,
          "interval": "MONTH"
        },
        "type": "SINGLE_PAYMENT",
        "price": {
          "price": "1000",
          "currency": "USD"
        }
      },
      "minimum_purchase_quantity": 1,
      "maximum_purchase_quantity": 1,
      "bulk_discount": [],
      "payment_methods": [
        "PAYPAL"
      ],
      "other_settings": {
        "quantity_increments": 0,
        "discord_data_required": false,
        "discord_kick_on_expire": true,
        "community_servers": []
      },
      "order": 1,
      "created_at": "2026-08-30T12:00:01.000000Z",
      "updated_at": "2026-08-30T12:00:01.000000Z",
      "deleted_at": null,
      "product": {
        "additional_information": [
          {
            "required": true,
            "key": "5ebae238c0afae7f4a4b96b30ff6f34c",
            "type": "CHECKBOX",
            "label": "I agree to the purchase terms"
          }
        ]
      }
    }
  ]
}
{
  "data": [
    {
      "id": 2,
      "product_id": 1,
      "title": "Default",
      "description": "Default product variant.",
      "deliverable": {
        "types": [
          "TEXT"
        ],
        "data": {
          "serials": [
            "SERIAL-001"
          ],
          "parsingMode": "NEW_LINE",
          "removeDuplicate": true,
          "stock": 1
        }
      },
      "pricing": {
        "humble": false,
        "frequency": {
          "value": 1,
          "interval": "MONTH"
        },
        "type": "SINGLE_PAYMENT",
        "price": {
          "price": "1000",
          "currency": "USD"
        }
      },
      "minimum_purchase_quantity": 1,
      "maximum_purchase_quantity": 1,
      "bulk_discount": [],
      "payment_methods": [
        "PAYPAL"
      ],
      "other_settings": {
        "quantity_increments": 0,
        "discord_data_required": false,
        "discord_kick_on_expire": true,
        "community_servers": []
      },
      "order": 1,
      "created_at": "2026-08-30T12:00:01.000000Z",
      "updated_at": "2026-08-30T12:00:01.000000Z",
      "deleted_at": null,
      "product": {
        "additional_information": [
          {
            "required": true,
            "key": "5ebae238c0afae7f4a4b96b30ff6f34c",
            "type": "CHECKBOX",
            "label": "I agree to the purchase terms"
          }
        ]
      }
    }
  ]
}
{
  "type": "invalid_request_error",
  "code": "bad_request",
  "message": "The request could not be understood.",
  "status": 400,
  "param": null,
  "request_id": "01992a65-e064-71ba-b38f-902b7966a6be",
  "docs_url": "https://sell.app/docs/api/errors#bad-request"
}
{
  "type": "authentication_error",
  "code": "unauthenticated",
  "message": "Unauthenticated.",
  "status": 401,
  "param": null,
  "request_id": "01992a65-e064-71ba-b38f-902b7966a6be",
  "docs_url": "https://sell.app/docs/api/errors#unauthenticated"
}
{
  "type": "authorization_error",
  "code": "forbidden",
  "message": "This action is unauthorized.",
  "status": 403,
  "param": null,
  "request_id": "01992a65-e064-71ba-b38f-902b7966a6be",
  "docs_url": "https://sell.app/docs/api/errors#forbidden"
}
{
  "type": "not_found_error",
  "code": "resource_not_found",
  "message": "Not Found.",
  "status": 404,
  "param": null,
  "request_id": "01992a65-e064-71ba-b38f-902b7966a6be",
  "docs_url": "https://sell.app/docs/api/errors#resource-not-found"
}
{
  "type": "validation_error",
  "code": "validation_failed",
  "message": "The selected product variant id is invalid.",
  "status": 422,
  "param": "product_variant_id",
  "request_id": "01992a65-e064-71ba-b38f-902b7966a6be",
  "docs_url": "https://sell.app/docs/api/errors#validation-failed",
  "errors": {
    "product_variant_id": [
      "The selected product variant id is invalid."
    ]
  }
}
{
  "type": "rate_limit_error",
  "code": "rate_limit_exceeded",
  "message": "Too Many Attempts.",
  "status": 429,
  "param": null,
  "request_id": "01992a65-e064-71ba-b38f-902b7966a6be",
  "docs_url": "https://sell.app/docs/api/errors#rate-limit-exceeded"
}
{
  "type": "api_error",
  "code": "api_error",
  "message": "Server Error",
  "status": 500,
  "param": null,
  "request_id": "01992a65-e064-71ba-b38f-902b7966a6be",
  "docs_url": "https://sell.app/docs/api/errors#api-error"
}